// mng4iectl.cpp
// Part of MNG4IE.
// Copyright 2002-2004 by Jason Summers

#include "stdafx.h"

#if defined(UNICODE) || defined(_UNICODE)
#error See comments in source code about UNICODE.
// This might compile with Unicode, but it hasn't really been tested,
// and there are probably some problems with it, some of which are
// marked with "possible unicode problem" comments.
// Choose a different configuration, or remove the line above if you want
// to try compiling with Unicode.
#endif

#include "mng4ie.h"
#include "bindstatuscallback.h"

// ---------------
// If you get an error about INT32 in jmorecfg.h, try modifying
// jmorecfg.h by changing:
//   typedef long INT32;
// to:
//   #ifdef JPEG_INTERNALS
//   typedef long INT32;
//   #endif
//   -----------
// If you get errors in lcms.h, try removing or renaming each
// occurrence of the FAR macro.
//   -----------
// Remove these #defines if necessary:
//#define MNG_ERROR_TELLTALE
//#define MNG_FULL_CMS
//#define MNG_SUPPORT_DYNAMICMNG
//   -----------
//#include <libmng.h>
// ---------------

#include <hlink.h>
#include <commdlg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <stdarg.h>

#include <jversion.h>      // part of libjpeg
#include <zlib.h>          // for zlibVersion

#include "mngctrl.h"
#include "mng4iectl.h"

#define MNG4IE_CMS
//#define MNG4IE_TRACE

#define IDBASE           47000
#define ID_SAVEAS        (IDBASE+0)
#define ID_COPYIMAGE     (IDBASE+1)
#define ID_COPYURL       (IDBASE+2)
#define ID_VIEWIMAGE     (IDBASE+3)
#define ID_ABOUT         (IDBASE+4)
#define ID_FREEZE        (IDBASE+5)
#define ID_RESTARTANIM   (IDBASE+6)
#define ID_COPYLINKLOC   (IDBASE+7)
#define ID_STOPANIM      (IDBASE+8)
#define ID_SHOWERROR     (IDBASE+9)
#define ID_PROPERTIES    (IDBASE+10)


#ifdef MNG4IE_TRACE
static FILE *tracefile;
#endif

extern "C" struct globals_struct globals;


/////////////////////////////////////////////////////////////////////////////
// Cmng4iectl
void Cmng4iectl::CallPlgNew()
{
	OLE_COLOR clrBackColor;
	int bgcolorknown;


	if(m_plgnew_called) return; // already done this

	m_plginst.pdata = NULL;
	m_plginst.ctl = (void*)this;

	bgcolorknown=0;
	clrBackColor = RGB(255,255,255);
	if (SUCCEEDED (GetAmbientBackColor (clrBackColor))) {
		bgcolorknown=1;
	}

	PLG_New(&m_plginst,m_embedmode,bgcolorknown,(COLORREF)clrBackColor);

	m_plgnew_called=1;
}

Cmng4iectl::Cmng4iectl()
{
	m_bWindowOnly = TRUE;

	m_plgnew_called=0;
	m_embedmode=PLGMODE_EMBED;

	//m_force_bgcolor=0;
	//m_bg_r = m_bg_g = m_bg_b = 0xff;
	//m_fhWnd = NULL;

	//// This will have to be deferred until ::Load
	//m_scrolling=0;   //m_scrolling = (mode==NP_FULL);

	//m_xscrollpos = m_yscrollpos = 0;
	//m_windowwidth = m_windowheight = 0;
	m_loadstate = STATE_INIT;
	m_paintedyet = 0;
	//m_mng=0;
	//m_lpdib=NULL;
	lstrcpy(m_url,_T(""));
	//m_frozen=0;
	//m_needresume=0;
	m_errorflag=0;
	//lstrcpy(m_errormsg,_T(""));
	//m_dibsize = m_filesize = 0;
	//lstrcpy(m_linkurl,_T(""));
	//lstrcpy(m_linktarget,_T("_self"));
	//m_islink=0;
	//m_bkgdbrush=NULL;
	//m_fullscreen=0;
	//m_timer_set=0;
	//m_timer2_set=0;
	//m_dynamicmng= -1;
	//m_mouse_over_mng=0;
	//m_mouse_captured=0;
}


Cmng4iectl::~Cmng4iectl()
{

	if(m_plgnew_called) {
		PLG_Destroy(&m_plginst);
		m_plgnew_called=0;
	}

	// should any of this be moved to OnDestroy?

//	if(m_mng) {
//		m_dynamicmng=0;
//		mng_cleanup(&m_mng); 
//		m_mng=0;
//	}
//	if(m_lpdib) {
//		free(m_lpdib);
//		m_lpdib=NULL;
//	}
//	if(m_mngdata) {
//		free(m_mngdata);
//		m_mngdata=NULL;
//		m_bytesalloc=0;
//	}
//	if(m_textdata) {
//		free(m_textdata);
//		m_textdata=NULL;
//	}

//	if(m_bkgdbrush) DeleteObject((HGDIOBJ)m_bkgdbrush);

}

STDMETHODIMP Cmng4iectl::GetInterfaceSafetyOptions( REFIID riid,
                                       DWORD *pdwSupportedOptions,
                                       DWORD *pdwEnabledOptions )
{
  *pdwSupportedOptions = INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA;
  *pdwEnabledOptions = *pdwSupportedOptions;
  return S_OK;
}

STDMETHODIMP Cmng4iectl::SetInterfaceSafetyOptions( REFIID riid,
                                       DWORD dwOptionsSetMask,
                                       DWORD dwEnabledOptions )
{
  return S_OK;
}


HRESULT Cmng4iectl::OnDraw(ATL_DRAWINFO& di)
{
	//RECT& rect = *(RECT*)di.prcBounds;
	//RECT rect2;
	//HDC hdc = di.hdcDraw;

#if 0     // fixme?  support printing?
	::SetWindowOrgEx(hdc,m_xscrollpos,m_yscrollpos,NULL);

	//::GetClientRect(hWnd,&rect);
	if(m_errorflag || !m_lpdib) {
		::SelectObject(hdc,globals.hfontMsg);
		::Rectangle(hdc,rect.left,rect.top,rect.right,rect.bottom);
		rect2.left=rect.left+2;
		rect2.top=rect.top+2;
		rect2.right=rect.right-2;
		rect2.bottom=rect.bottom-2;
		if(m_errorflag) {
			::DrawText(hdc,_T("MNG4IE ERROR!"),-1,&rect2,DT_LEFT|DT_WORDBREAK);
		}
		else {
			if(m_loadstate>=STATE_LOADING) {
				::DrawText(hdc,_T("MNG image loading..."),-1,&rect2,DT_LEFT|DT_WORDBREAK);
			}
			else {
				::DrawText(hdc,_T("MNG4IE"),-1,&rect2,DT_LEFT|DT_WORDBREAK);
			}
		}
	}
	else if(m_lpdib) {
		::StretchDIBits(hdc,
			0,0,m_lpdibinfo->biWidth,m_lpdibinfo->biHeight,
			0,0,m_lpdibinfo->biWidth,m_lpdibinfo->biHeight,
			&((BYTE*)(m_lpdib))[sizeof(BITMAPINFOHEADER)],
			(LPBITMAPINFO)m_lpdib,DIB_RGB_COLORS,SRCCOPY);
	}

#endif

	return S_OK;
}


LRESULT Cmng4iectl::OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//m_fhWnd = m_hWnd;

	if(!m_plgnew_called) {
		CallPlgNew(); // in case this hasn't been done yet
		PLG_ParamDone(&m_plginst);
	}

	PLG_NewWindow(&m_plginst,m_hWnd);
	//find_window_size();
	//set_scrollbars();

	// It's easiest to wait till we have a window to start the
	// download, because the timer that the animation needs
	// uses a window.
	if(lstrlen(m_url)) {
		DownloadURL(CComBSTR(m_url));
	}
	//InvalidateRect( m_fhWnd, NULL, TRUE );
	//UpdateWindow( m_fhWnd );
	return 0;
}


LRESULT Cmng4iectl::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
//	if(m_timer_set) {
//		::KillTimer(m_fhWnd,1);
//		m_timer_set=0;
//	}
//	if(m_timer2_set) {
//		::KillTimer(m_fhWnd,2);
//		m_timer2_set=0;
//	}
//	if(m_mouse_captured) {
//		::ReleaseCapture();
//		m_mouse_captured=0;
//	}
//	m_fhWnd = NULL;
	return 0;
}


STDMETHODIMP Cmng4iectl::DownloadURL(BSTR strURL)
{
	int propId;
	propId = 3456;

	COurBindStatusCallback<Cmng4iectl>::Download(this, OnData, strURL, 
		propId, m_spClientSite, TRUE);
	return S_OK;
}

int Cmng4iectl::ReadParamString(LPPROPERTYBAG pPropBag, LPERRORLOG pErrorLog,
								WCHAR *name, TCHAR *buf, int bufsize)
{
    VARIANT v;
	HRESULT hr;
	int retval=0;

	v.vt = VT_EMPTY; v.bstrVal = NULL;
	hr = pPropBag->Read(name, &v, pErrorLog);
	if(SUCCEEDED(hr)) {
		if(v.vt==VT_BSTR && v.bstrVal) {
			USES_CONVERSION;
			lstrcpyn(buf,OLE2T(v.bstrVal),bufsize);
			retval=1;
		}
		VariantClear(&v);
	}
	return retval;
}

static unsigned char gethex(const TCHAR *s)
{
	int v[2];
	int i;

	v[0]=v[1]=0; 
	for(i=0;i<2;i++) {
		if(s[i]>=_T('a') && s[i]<=_T('f')) v[i]=s[i]-87;
		if(s[i]>=_T('A') && s[i]<=_T('F')) v[i]=s[i]-55;
		if(s[i]>=_T('0') && s[i]<=_T('9')) v[i]=s[i]-48;
	}
	return (unsigned char)(v[0]*16+v[1]);
}

static void hexcolor2rgb(const TCHAR *s, unsigned int *r, unsigned int *g, unsigned int *b)
{
	if(lstrlen(s)!=7) return;
	if(s[0]!=_T('#')) return;
	(*r)= gethex(&s[1]);
	(*g)= gethex(&s[3]);
	(*b)= gethex(&s[5]);
}

// Load is called before OnCreate, but it may not be called at
// all if there are no parameters.
STDMETHODIMP Cmng4iectl::Load(LPPROPERTYBAG pPropBag, LPERRORLOG pErrorLog)
{
	TCHAR buf[500];
	//COLORREF bgcolor;

	// examine the <embed>/<param> tag arguments

	ReadParamString(pPropBag,pErrorLog,L"src",m_url,MAXLEN_URL);

	if(ReadParamString(pPropBag,pErrorLog,L"FULLSCREEN",buf,50)) {
		if(buf[0]=='Y' || buf[0]=='y') {
			//m_fullscreen=1;
			m_embedmode=PLGMODE_FULL;
			//m_scrolling=1;
		}
	}


//	if(ReadParamString(pPropBag,pErrorLog,L"bgcolor",buf,50)) {
//		hexcolor2rgb(buf,&m_bg_r,&m_bg_g,&m_bg_b);
//	}
//	else {

	// now we know embedmode, so we can call _New.
	CallPlgNew();


	//m_bkgdbrush=CreateSolidBrush(RGB(m_bg_r,m_bg_g,m_bg_b));
	//m_force_bgcolor=1; // this is always ON now. should probably remove it..

	//if(ReadParamString(pPropBag,pErrorLog,L"href",m_linkurl,MAXLEN_URL)) {
	//	m_islink=1;
	//}

	//ReadParamString(pPropBag,pErrorLog,L"target",m_linktarget,MAXLEN_TARGET);

	// fixme: just read all params
	if(ReadParamString(pPropBag,pErrorLog,L"href",buf,500)) {
		PLG_Param(&m_plginst,"href",buf);
	}
	if(ReadParamString(pPropBag,pErrorLog,L"target",buf,500)) {
		PLG_Param(&m_plginst,"target",buf);
	}
	if(ReadParamString(pPropBag,pErrorLog,L"bgcolor",buf,500)) {
		PLG_Param(&m_plginst,"bgcolor",buf);
	}

	PLG_ParamDone(&m_plginst);

    return IPersistPropertyBagImpl<Cmng4iectl>::Load(pPropBag, pErrorLog);
}

#define MNG4IE_ALLOC_CHUNK_SIZE   131072
#define MNG4IE_MAX_FILE_SIZE      100000000

void Cmng4iectl::OnData(COurBindStatusCallback<Cmng4iectl>* pbsc, DWORD grfBSCF, BYTE* pBytes, DWORD dwSize)
{
	if(m_errorflag) return;
	if(m_loadstate>=STATE_LOADED) return;
	if(pbsc->m_propId != 3456) return; // wrong stream

	if(grfBSCF & BSCF_FIRSTDATANOTIFICATION) {
		//m_libmngpos=0;
		m_bytesloaded=0;
		//m_bytesalloc=0;
		//m_byteswanted=0;
		//m_mngdata=NULL;
		//m_textdata=NULL;

		//if(pbsc->m_dwTotalStreamSize > 0) {
			//if(pbsc->m_dwTotalStreamSize > MNG4IE_MAX_FILE_SIZE) {
			//	set_error(_T("File too large"));
			//	return;
			//}
			//m_mngdata = (unsigned char*)malloc(pbsc->m_dwTotalStreamSize);
			//m_bytesalloc= pbsc->m_dwTotalStreamSize;
		//}
		//my_init_mng();
		PLG_NewStream(&m_plginst,NULL /* fixme */,
				m_url, pbsc->m_dwTotalStreamSize);


		m_loadstate=STATE_LOADING;

	}

//	if(m_bytesloaded+dwSize > (int)m_bytesalloc) {  // oops, overflowed our memory buffer
//		if(m_bytesalloc > MNG4IE_MAX_FILE_SIZE) {
//				set_error(_T("File too large"));
//				return;
//		}
//		m_bytesalloc += MNG4IE_ALLOC_CHUNK_SIZE;
//		if(m_mngdata) {
//			m_mngdata= (unsigned char*)realloc((void*)m_mngdata, m_bytesalloc);
//		}
//		else {  // first time
//			m_mngdata= (unsigned char*)malloc(m_bytesalloc);
//		}
//		if(!m_mngdata) {
//			set_error(_T("Could not allocate memory for image (%d,%d,%p)"),m_bytesloaded,dwSize,pBytes);
//			return;
//		}
//	}

	// now we should have enough room to copy the data to memory

	//CopyMemory(&m_mngdata[m_bytesloaded],pBytes,dwSize);
	PLG_Write(&m_plginst,NULL,m_bytesloaded,dwSize,pBytes);

	m_bytesloaded += dwSize;

	// now, check if it's time to call mng_read_resume
//	if(m_needresume &&
//		(m_bytesloaded >= (m_libmngpos + m_byteswanted)) )
//	{
//		m_needresume=0;
//
//#ifdef MNG4IE_TRACE
//	fprintf(tracefile,"NPP_Write display_resume bytesloaded=%d libmngpos=%d byteswanted=%d\n",
//		m_bytesloaded,m_libmngpos,m_byteswanted);
//#endif
//
//		handle_read_error(mng_display_resume(m_mng) );
//	}


	if(grfBSCF & BSCF_LASTDATANOTIFICATION) {
		//m_filesize = m_bytesloaded;
		m_loadstate = STATE_LOADED;

		PLG_DestroyStream(&m_plginst,NULL,PLGRES_DONE);
//#ifdef MNG4IE_TRACE
//		fprintf(tracefile,"NPP_DestroyStream reason=%d needresume=%d\n",reason,m_needresume);
//#endif

//		if(m_needresume) {
//			m_needresume=0;
//			handle_read_error(mng_display_resume(m_mng) );
//		}
	}
}

void Cmng4iectl::warn(TCHAR *fmt, ...)
{
	va_list ap;
	TCHAR buf[2048];

	va_start(ap, fmt);
	wvsprintf(buf,fmt, ap);
	va_end(ap);

	::MessageBox(m_hWnd,buf,_T("MNG4IE"),MB_OK|MB_ICONWARNING);
}


STDMETHODIMP Cmng4iectl::get_Version(long *pVal)
{
	//*pVal = MNG4IEVERS_INT;
	*pVal = script_GetVersion(&m_plginst);
	return S_OK;
}

STDMETHODIMP Cmng4iectl::Animate(long x)
{
	script_Animate(&m_plginst,x);

	return S_OK;
}

PLGERRCODE Cmng4iectl::InternalSERVICE_GetURL(PLGINST plginst, const char *url, const char *target)
{
	USES_CONVERSION;

	HlinkSimpleNavigateToString(A2W(url),NULL,
		A2W(target),GetUnknown(),NULL,NULL,
		HLNF_INTERNALJUMP,0);

	return PLGERR_NO_ERROR;
}


BEGIN_C_DEFS

PLGERRCODE PLGSERVICE_GetURL(PLGINST plginst, const char *url, const char *target)
{
	Cmng4iectl *ctl;
	
	ctl = (Cmng4iectl*)plginst->ctl;

	return ctl->InternalSERVICE_GetURL(plginst,url,target);
}

END_C_DEFS

